Index: trunk/NEMO/TOP_SRC/oce_trc.F90
===================================================================
--- trunk/NEMO/TOP_SRC/oce_trc.F90	(revision 261)
+++ trunk/NEMO/TOP_SRC/oce_trc.F90	(revision 262)
@@ -7,7 +7,5 @@
    !!   9.0  !  04-03  (C. Ethe)  F90: Free form and module
    !!----------------------------------------------------------------------
-   !!  TOP 1.0 , LOCEAN-IPSL (2005)
-   !! $Header$
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt
+   !!  OPA 9.0 , LODYC-IPSL (2003)
    !!----------------------------------------------------------------------
    !! * Modules used
@@ -42,9 +40,8 @@
       nstock   =>   nstock,  & !: frequency of restart file
       lwp      =>   lwp   ,  & !: boolean term for mpp output
-      l_ctl    =>   l_ctl ,  & !: = ln_ctl.AND.lwp (print control on the 1st proc)
-      nictl    =>   nictl ,  & !: = max i indice to make the control SUM
-      njctl    =>   njctl ,  & !: = max j indice to make the control SUM
-      numout   =>   numout,  & !: logical unit for output print
-      numwrs   =>   numwrs     !: logical unit for output restart
+      ln_ctl   =>   ln_ctl ,  & !: = ln_ctl.AND.lwp (print control on the 1st proc)
+      nictle   =>   nictle ,  & !: = max i indice to make the control SUM
+      njctle   =>   njctle ,  & !: = max j indice to make the control SUM
+      numout   =>   numout     !: logical unit for output print
 
    !! run controm   
@@ -119,4 +116,7 @@
       lk_dynspg_fsc_tsk   =>  lk_dynspg_fsc_tsk      !: free surface constant volume flag
 
+   USE zdf_oce,    ONLY :          &
+      ln_zdfnpc   =>   ln_zdfnpc      !: convection: non-penetrative convection flag
+
 #if defined key_partial_steps
    !! Partial steps ('key_partial_steps')
@@ -144,5 +144,4 @@
       hbatu   =>   hbatu  ,  & !: ocean depth at the vertical of  u-point (m)
       hbatv   =>   hbatv  ,  & !: ocean depth at the vertical of w-point (m)
-      hbatf   =>   hbatw  ,  & !: ocean depth at the vertical of f-point (m)
       gsigt   =>   gsigt  ,  & !: model level depth coefficient at t-,  & w-levelsvertical scale factors at u-
       gsigw   =>   gsigw  ,  & !: model level depth coefficient at t-,  & w-levelsvertical scale factors v-
@@ -155,4 +154,5 @@
    USE dom_oce , ONLY :             &    
       mbathy   =>   mbathy,  & !: number of ocean level (=0,  & 1, ... , jpk-1) 
+      tmask_i  =>   tmask_i, & !: Interior mask at t-points
       tmask    =>   tmask ,  & !: land/ocean mask at t-points
       umask    =>   umask ,  & !: land/ocean mask at u-points   
@@ -172,6 +172,9 @@
 
    USE daymod , ONLY :                 &
-      ndastp    =>   ndastp,  & !: time step date in year/month/day aammjj
-      nday_year =>   nday_year  !: curent day counted from jan 1st of the current year
+      ndastp    =>   ndastp,  &    !: time step date in year/month/day aammjj
+      nday_year =>   nday_year, &  !: curent day counted from jan 1st of the current year
+      nyear     =>   nyear,   &  !: Current year
+      nmonth    =>   nmonth,  &  !: Current month
+      nday      =>   nday        !: Current day
 
    !! physical constants
@@ -230,5 +233,4 @@
    USE zdf_oce , ONLY :      &    
       avt     =>   avt    ,  & !: vert. diffusivity coef. at w-point for temp  
-      avm0    =>   avm0   ,  & !: vertical eddy viscosity for the dynamic (m2/s)
       avt0    =>   avt0        !: vertical eddy diffusivity for tracers (m2/s)
 
Index: trunk/NEMO/TOP_SRC/par_trc.F90
===================================================================
--- trunk/NEMO/TOP_SRC/par_trc.F90	(revision 261)
+++ trunk/NEMO/TOP_SRC/par_trc.F90	(revision 262)
@@ -10,7 +10,5 @@
    !!   9.0  !  04-03  (C. Ethe)  Free form and module
    !!----------------------------------------------------------------------
-   !!  TOP 1.0 , LOCEAN-IPSL (2005)
-   !! $Header$
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt
+   !!  OPA 9.0, LODYC-IPSL (2004)
    !!----------------------------------------------------------------------
    !! * Modules used
Index: trunk/NEMO/TOP_SRC/par_trc_trp.F90
===================================================================
--- trunk/NEMO/TOP_SRC/par_trc_trp.F90	(revision 261)
+++ trunk/NEMO/TOP_SRC/par_trc_trp.F90	(revision 262)
@@ -12,7 +12,5 @@
    !!---------------------------------------------------------------------
    !!----------------------------------------------------------------------
-   !!  TOP 1.0 , LOCEAN-IPSL (2005)
-   !! $Header$
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt
+   !!  OPA 9.0, LODYC-IPSL (2004)
    !!----------------------------------------------------------------------
 
Index: trunk/NEMO/TOP_SRC/passivetrc_substitute.h90
===================================================================
--- trunk/NEMO/TOP_SRC/passivetrc_substitute.h90	(revision 261)
+++ trunk/NEMO/TOP_SRC/passivetrc_substitute.h90	(revision 262)
@@ -6,9 +6,5 @@
    !! ----------------------------------------------------------------------
    !!
-   !!----------------------------------------------------------------------
-   !!  TOP 1.0 , LOCEAN-IPSL (2005)
-   !! $Header$
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt
-   !!----------------------------------------------------------------------
+
     ! Lateral eddy diffusivity coefficient for passive tracer:
     ! ========================================================