Index: trunk/CONFIG/ORCA2_LIM/scripts/BB_make.ldef
===================================================================
--- trunk/CONFIG/ORCA2_LIM/scripts/BB_make.ldef	(revision 300)
+++ trunk/CONFIG/ORCA2_LIM/scripts/BB_make.ldef	(revision 305)
@@ -24,17 +24,17 @@
 #-
 #-Q- sxnec  ## ORCA2-LIM standard
-#-Q- sxnec  P_P = -Wp,-Dkey_partial_steps -Wp,-Dkey_trabbl_dif -Wp,-Dkey_vectopt_loop -Wp,-Dkey_vectopt_memory -Wp,-Dkey_orca_r2 -Wp,-Dkey_ice_lim -Wp,-Dkey_lim_fdd -Wp,-Dkey_dynspg_fsc -Wp,-Dkey_diaeiv -Wp,-Dkey_ldfslp  -Wp,-Dkey_traldf_c2d -Wp,-Dkey_traldf_eiv -Wp,-Dkey_dynldf_c3d -Wp,-Dkey_dtatem -Wp,-Dkey_dtasal -Wp,-Dkey_tau_monthly -Wp,-Dkey_flx_bulk_monthly -Wp,-Dkey_diagap -Wp,-Dkey_tradmp -Wp,-Dkey_trabbc -Wp,-Dkey_zdftke -Wp,-Dkey_zdfddm
+#-Q- sxnec  P_P = -Wp,-Dkey_partial_steps -Wp,-Dkey_trabbl_dif -Wp,-Dkey_vectopt_loop -Wp,-Dkey_vectopt_memory -Wp,-Dkey_orca_r2 -Wp,-Dkey_ice_lim -Wp,-Dkey_lim_fdd -Wp,-Dkey_dynspg_fsc -Wp,-Dkey_diaeiv -Wp,-Dkey_ldfslp  -Wp,-Dkey_traldf_c2d -Wp,-Dkey_traldf_eiv -Wp,-Dkey_dynldf_c3d -Wp,-Dkey_dtatem -Wp,-Dkey_dtasal -Wp,-Dkey_tau_monthly -Wp,-Dkey_flx_bulk_monthly -Wp,-Dkey_tradmp -Wp,-Dkey_trabbc -Wp,-Dkey_zdftke -Wp,-Dkey_zdfddm
 #-
 #-Q- sxnec  ## ORCA2-LIM autotasking
-#-Q- sxnec  ## P_P = -Wp,-Dkey_autotasking -Wp,-Dkey_partial_steps -Wp,-Dkey_trabbl_dif -Wp,-Dkey_vectopt_loop -Wp,-Dkey_vectopt_memory -Wp,-Dkey_orca_r2 -Wp,-Dkey_ice_lim -Wp,-Dkey_lim_fdd -Wp,-Dkey_dynspg_fsc -Wp,-Dkey_diaeiv -Wp,-Dkey_ldfslp -Wp,-Dkey_traldf_c2d -Wp,-Dkey_traldf_eiv -Wp,-Dkey_dynldf_c3d -Wp,-Dkey_dtatem -Wp,-Dkey_dtasal -Wp,-Dkey_tau_monthly -Wp,-Dkey_flx_bulk_monthly -Wp,-Dkey_diagap -Wp,-Dkey_tradmp -Wp,-Dkey_trabbc -Wp,-Dkey_zdftke -Wp,-Dkey_zdfddm 
+#-Q- sxnec  ## P_P = -Wp,-Dkey_autotasking -Wp,-Dkey_partial_steps -Wp,-Dkey_trabbl_dif -Wp,-Dkey_vectopt_loop -Wp,-Dkey_vectopt_memory -Wp,-Dkey_orca_r2 -Wp,-Dkey_ice_lim -Wp,-Dkey_lim_fdd -Wp,-Dkey_dynspg_fsc -Wp,-Dkey_diaeiv -Wp,-Dkey_ldfslp -Wp,-Dkey_traldf_c2d -Wp,-Dkey_traldf_eiv -Wp,-Dkey_dynldf_c3d -Wp,-Dkey_dtatem -Wp,-Dkey_dtasal -Wp,-Dkey_tau_monthly -Wp,-Dkey_flx_bulk_monthly -Wp,-Dkey_tradmp -Wp,-Dkey_trabbc -Wp,-Dkey_zdftke -Wp,-Dkey_zdfddm 
 #-
 #-Q- sx6nec  ## ORCA2-LIM standard
-#-Q- sx6nec  P_P = '-Wp,-Dkey_partial_steps -Wp,-Dkey_trabbl_dif -Wp,-Dkey_vectopt_loop -Wp,-Dkey_vectopt_memory -Wp,-Dkey_orca_r2 -Wp,-Dkey_ice_lim -Wp,-Dkey_lim_fdd -Wp,-Dkey_dynspg_fsc -Wp,-Dkey_diaeiv -Wp,-Dkey_ldfslp -Wp,-Dkey_traldf_c2d -Wp,-Dkey_traldf_eiv -Wp,-Dkey_dynldf_c3d -Wp,-Dkey_dtatem -Wp,-Dkey_dtasal -Wp,-Dkey_tau_monthly -Wp,-Dkey_flx_bulk_monthly -Wp,-Dkey_diagap -Wp,-Dkey_tradmp -Wp,-Dkey_trabbc -Wp,-Dkey_zdftke -Wp,-Dkey_zdfddm'
+#-Q- sx6nec  P_P = '-Wp,-Dkey_partial_steps -Wp,-Dkey_trabbl_dif -Wp,-Dkey_vectopt_loop -Wp,-Dkey_vectopt_memory -Wp,-Dkey_orca_r2 -Wp,-Dkey_ice_lim -Wp,-Dkey_lim_fdd -Wp,-Dkey_dynspg_fsc -Wp,-Dkey_diaeiv -Wp,-Dkey_ldfslp -Wp,-Dkey_traldf_c2d -Wp,-Dkey_traldf_eiv -Wp,-Dkey_dynldf_c3d -Wp,-Dkey_dtatem -Wp,-Dkey_dtasal -Wp,-Dkey_tau_monthly -Wp,-Dkey_flx_bulk_monthly -Wp,-Dkey_tradmp -Wp,-Dkey_trabbc -Wp,-Dkey_zdftke -Wp,-Dkey_zdfddm'
 #-
 #-Q- sx6nec  ## ORCA2-LIM autotasking
-#-Q- sx6nec  ## P_P = '-Wp,-Dkey_autotasking -Wp,-Dkey_partial_steps -Wp,-Dkey_trabbl_dif -Wp,-Dkey_vectopt_loop -Wp,-Dkey_vectopt_memory -Wp,-Dkey_orca_r2 -Wp,-Dkey_ice_lim -Wp,-Dkey_lim_fdd -Wp,-Dkey_dynspg_fsc -Wp,-Dkey_diaeiv -Wp,-Dkey_ldfslp -Wp,-Dkey_traldf_c2d -Wp,-Dkey_traldf_eiv -Wp,-Dkey_dynldf_c3d -Wp,-Dkey_dtatem -Wp,-Dkey_dtasal -Wp,-Dkey_tau_monthly -Wp,-Dkey_flx_bulk_monthly -Wp,-Dkey_diagap -Wp,-Dkey_tradmp -Wp,-Dkey_trabbc -Wp,-Dkey_zdftke -Wp,-Dkey_zdfddm' 
+#-Q- sx6nec  ## P_P = '-Wp,-Dkey_autotasking -Wp,-Dkey_partial_steps -Wp,-Dkey_trabbl_dif -Wp,-Dkey_vectopt_loop -Wp,-Dkey_vectopt_memory -Wp,-Dkey_orca_r2 -Wp,-Dkey_ice_lim -Wp,-Dkey_lim_fdd -Wp,-Dkey_dynspg_fsc -Wp,-Dkey_diaeiv -Wp,-Dkey_ldfslp -Wp,-Dkey_traldf_c2d -Wp,-Dkey_traldf_eiv -Wp,-Dkey_dynldf_c3d -Wp,-Dkey_dtatem -Wp,-Dkey_dtasal -Wp,-Dkey_tau_monthly -Wp,-Dkey_flx_bulk_monthly -Wp,-Dkey_tradmp -Wp,-Dkey_trabbc -Wp,-Dkey_zdftke -Wp,-Dkey_zdfddm' 
 #-
 #-Q- aix     ## ORCA2-LIM standard
-#-Q- aix     P_P = -WF,-Dkey_partial_steps -WF,-Dkey_trabbl_dif -WF,-Dkey_vectopt_loop -WF,-Dkey_vectopt_memory -WF,-Dkey_orca_r2 -WF,-Dkey_ice_lim -WF,-Dkey_lim_fdd -WF,-Dkey_dynspg_fsc -WF,-Dkey_diaeiv -WF,-Dkey_ldfslp  -WF,-Dkey_traldf_c2d -WF,-Dkey_traldf_eiv -WF,-Dkey_dynldf_c3d -WF,-Dkey_dtatem -WF,-Dkey_dtasal -WF,-Dkey_tau_monthly -WF,-Dkey_flx_bulk_monthly -WF,-Dkey_diagap -WF,-Dkey_tradmp -WF,-Dkey_trabbc -WF,-Dkey_zdftke -WF,-Dkey_zdfddm
+#-Q- aix     P_P = -WF,-Dkey_partial_steps -WF,-Dkey_trabbl_dif -WF,-Dkey_vectopt_memory -WF,-Dkey_orca_r2 -WF,-Dkey_ice_lim -WF,-Dkey_lim_fdd -WF,-Dkey_dynspg_fsc -WF,-Dkey_diaeiv -WF,-Dkey_ldfslp  -WF,-Dkey_traldf_c2d -WF,-Dkey_traldf_eiv -WF,-Dkey_dynldf_c3d -WF,-Dkey_dtatem -WF,-Dkey_dtasal -WF,-Dkey_tau_monthly -WF,-Dkey_flx_bulk_monthly -WF,-Dkey_trabbc -WF,-Dkey_zdftke -WF,-Dkey_zdfddm
 #-
 