Index: trunk/NEMO/TOP_SRC/initrc.F90
===================================================================
--- trunk/NEMO/TOP_SRC/initrc.F90	(revision 339)
+++ trunk/NEMO/TOP_SRC/initrc.F90	(revision 340)
@@ -9,5 +9,7 @@
 
    !!-------------------------------------------------------
-   !!  TOP 1.0,  LOCEAN-IPSL (2005)
+   !!  TOP 1.0,  LOCEAN-IPSL (2005) 
+   !! $Header$ 
+   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
    !!-------------------------------------------------------
 
Index: trunk/NEMO/TOP_SRC/par_trc_trp.F90
===================================================================
--- trunk/NEMO/TOP_SRC/par_trc_trp.F90	(revision 339)
+++ trunk/NEMO/TOP_SRC/par_trc_trp.F90	(revision 340)
@@ -7,5 +7,7 @@
    !!   9.0  !  04-03  (C. Ethe)  Orignal
    !!----------------------------------------------------------------------
-   !!  TOP 1.0,  LOCEAN-IPSL (2005)
+   !!  TOP 1.0,  LOCEAN-IPSL (2005) 
+   !! $Header$ 
+   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
    !!----------------------------------------------------------------------
 #if defined key_passivetrc
Index: trunk/NEMO/TOP_SRC/trc.F90
===================================================================
--- trunk/NEMO/TOP_SRC/trc.F90	(revision 339)
+++ trunk/NEMO/TOP_SRC/trc.F90	(revision 340)
@@ -10,5 +10,7 @@
    !!   9.0  !  04-03  (C. Ethe)  Free form and module
    !!----------------------------------------------------------------------
-   !!  TOP 1.0,  LOCEAN-IPSL (2005)
+   !!  TOP 1.0,  LOCEAN-IPSL (2005) 
+   !! $Header$ 
+   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
    !!----------------------------------------------------------------------
 #if defined key_passivetrc
Index: trunk/NEMO/TOP_SRC/trcctl.F90
===================================================================
--- trunk/NEMO/TOP_SRC/trcctl.F90	(revision 339)
+++ trunk/NEMO/TOP_SRC/trcctl.F90	(revision 340)
@@ -9,5 +9,7 @@
    !!  O.Aumont and A.El Moussaoui 03/05 F90 
    !!=========================================================================
-   !!  TOP 1.0,  LOCEAN-IPSL (2005)
+   !!  TOP 1.0,  LOCEAN-IPSL (2005) 
+   !! $Header$ 
+   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
    !!----------------------------------------------------------------------
 #if defined key_passivetrc
Index: trunk/NEMO/TOP_SRC/trcdia.F90
===================================================================
--- trunk/NEMO/TOP_SRC/trcdia.F90	(revision 339)
+++ trunk/NEMO/TOP_SRC/trcdia.F90	(revision 340)
@@ -6,5 +6,7 @@
    !! O.Aumont and A.El Moussaoui 03/05 F90 
    !!==========================================================================
-   !!  TOP 1.0,  LOCEAN-IPSL (2005)
+   !!  TOP 1.0,  LOCEAN-IPSL (2005) 
+   !! $Header$ 
+   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
    !!----------------------------------------------------------------------
 #if defined key_passivetrc
Index: trunk/NEMO/TOP_SRC/trcdit.F90
===================================================================
--- trunk/NEMO/TOP_SRC/trcdit.F90	(revision 339)
+++ trunk/NEMO/TOP_SRC/trcdit.F90	(revision 340)
@@ -1,5 +1,7 @@
 MODULE trcdit
    !!----------------------------------------------------------------------
-   !!  TOP 1.0,  LOCEAN-IPSL (2005)
+   !!  TOP 1.0,  LOCEAN-IPSL (2005) 
+   !! $Header$ 
+   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
    !!----------------------------------------------------------------------
    !! * Modules used
Index: trunk/NEMO/TOP_SRC/trcdta.F90
===================================================================
--- trunk/NEMO/TOP_SRC/trcdta.F90	(revision 339)
+++ trunk/NEMO/TOP_SRC/trcdta.F90	(revision 340)
@@ -4,5 +4,7 @@
    !! Ocean data  :  read passive tracer data from monthly atlas data
    !!=====================================================================
-   !!  TOP 1.0,  LOCEAN-IPSL (2005)
+   !!  TOP 1.0,  LOCEAN-IPSL (2005) 
+   !! $Header$ 
+   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
    !!----------------------------------------------------------------------
 
Index: trunk/NEMO/TOP_SRC/trcini.F90
===================================================================
--- trunk/NEMO/TOP_SRC/trcini.F90	(revision 339)
+++ trunk/NEMO/TOP_SRC/trcini.F90	(revision 340)
@@ -7,4 +7,9 @@
    !!----------------------------------------------------------------------
    !!   trc_ini : Initialization for passive tracer
+   !!----------------------------------------------------------------------
+   !!----------------------------------------------------------------------
+   !!  TOP 1.0,  LOCEAN-IPSL (2005) 
+   !! $Header$ 
+   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
    !!----------------------------------------------------------------------
    !! * Modules used
Index: trunk/NEMO/TOP_SRC/trclec.F90
===================================================================
--- trunk/NEMO/TOP_SRC/trclec.F90	(revision 339)
+++ trunk/NEMO/TOP_SRC/trclec.F90	(revision 340)
@@ -6,5 +6,7 @@
    !! O.Aumont and A.El Moussaoui 03/05 F90
    !!=========================================================================
-   !!  TOP 1.0,  LOCEAN-IPSL (2005)
+   !!  TOP 1.0,  LOCEAN-IPSL (2005) 
+   !! $Header$ 
+   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
    !!----------------------------------------------------------------------
 #if defined key_passivetrc
Index: trunk/NEMO/TOP_SRC/trclsm.F90
===================================================================
--- trunk/NEMO/TOP_SRC/trclsm.F90	(revision 339)
+++ trunk/NEMO/TOP_SRC/trclsm.F90	(revision 340)
@@ -7,5 +7,7 @@
    !!
    !!=================================================================
-   !!  TOP 1.0,  LOCEAN-IPSL (2005)
+   !!  TOP 1.0,  LOCEAN-IPSL (2005) 
+   !! $Header$ 
+   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
    !!-----------------------------------------------------------------
 #if defined key_passivetrc
Index: trunk/NEMO/TOP_SRC/trcrst.F90
===================================================================
--- trunk/NEMO/TOP_SRC/trcrst.F90	(revision 339)
+++ trunk/NEMO/TOP_SRC/trcrst.F90	(revision 340)
@@ -7,5 +7,7 @@
    !!
    !!======================================================================
-   !!  TOP 1.0,  LOCEAN-IPSL (2005)
+   !!  TOP 1.0,  LOCEAN-IPSL (2005) 
+   !! $Header$ 
+   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
    !!----------------------------------------------------------------------
 #if defined key_passivetrc   
Index: trunk/NEMO/TOP_SRC/trcrst_fdir.h90
===================================================================
--- trunk/NEMO/TOP_SRC/trcrst_fdir.h90	(revision 339)
+++ trunk/NEMO/TOP_SRC/trcrst_fdir.h90	(revision 340)
@@ -6,5 +6,7 @@
       !!
       !!------------------------------------------------------------------------
-      !!  TOP 1.0,  LOCEAN-IPSL (2005)
+      !!  TOP 1.0,  LOCEAN-IPSL (2005) 
+   !! $Header$ 
+   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
       !!----------------------------------------------------------------------
       
Index: trunk/NEMO/TOP_SRC/trcsms.F90
===================================================================
--- trunk/NEMO/TOP_SRC/trcsms.F90	(revision 339)
+++ trunk/NEMO/TOP_SRC/trcsms.F90	(revision 340)
@@ -7,5 +7,7 @@
    !!
    !!===========================================================================================
-   !!  TOP 1.0,  LOCEAN-IPSL (2005)
+   !!  TOP 1.0,  LOCEAN-IPSL (2005) 
+   !! $Header$ 
+   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
    !!----------------------------------------------------------------------
 #if defined key_passivetrc   